#SetMaxColumns.ps1
#Sets columns of greater than 499 characters to 'max'
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SqlServer.SMO")  | out-null

$s = new-object ('Microsoft.SqlServer.Management.Smo.Server') 'SQLHASP1\SQLDEV01'
$db = $s.databases['WideRowDB']

if ($db.CompatibilityLevel -eq "Version90") {
	$tbs = $db.tables

	$tbs | foreach-object {
		$tb = $_
		$cols = $tb.columns
		$chd = [Boolean]0
		
		$cols | foreach-object {
			$col = $_
			if ($col.DataType.MaximumLength -gt 499) {
				$col.DataType.MaximumLength = -1
				$chd = [Boolean]1
			}
		
		if ($chd -eq "True") {
			$tb.Alter()
			}
		}
	}
}